import socket, sys
from time import sleep, time
from Queue import Queue

from Channel import Channel

# ew...
def getIP():
	s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	s.connect(('91.121.94.180', 80)) # doesn't matter if it fails
	addr = s.getsockname()[0] 
	s.close()
	return addr

class PdLANPoller(Channel):
	"""
		Broadcasts our IP address every two seconds.
		It's the poor GNU programmer's Bonjour! :)
		Also has the ability to broadcast arrays of Pd data, queued up with Post()
	"""
	def __init__(self, queue_type=Queue):
		self.queue = queue_type()
		Channel.__init__(self)
		self.create_socket(socket.AF_INET, socket.SOCK_DGRAM)
		self.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
		self.set_reuse_addr()
		self.dest = ('255.255.255.255', 10314)
		self.connect(self.dest)
		
		# what IP address the server is listening on
		if len(sys.argv) == 2:
			self.addr = sys.argv[1]
		else:
			self.addr = getIP()
		print "Listening on", self.addr
		print "(You can specify this with an argument)"
	
	# override asyncore.dispatcher's default send with a sendto instead
	"""def send(self, data):
		print "data:", data
		try:
			result = self.socket.sendto(data, self.dest)
			return result
		except socket.error, why:
			if why[0] == EWOULDBLOCK:
				return 0
			else:
				raise
			return 0"""
	
	def Launch(self):
		# elapsed time
		last = 0
		
		try:
			while 1:
				# broadcast the server IP address every two seconds
				if last < time() - 2:
					#print 'broadcasting ip...'
					self.Send(["ip", self.addr])
					last = time()
				# if we have UDP messages queued, then send them too
				while not self.queue.empty():
					self.Send(self.queue.get())
				self.Pump()
				sleep(0.001)
		except KeyboardInterrupt:
			sys.exit(0)
	
	def Post(self, data):
		""" Broadcast this array to all clients on the LAN. """
		self.queue.put(data)

if __name__ == "__main__":
	print PdLANPoller.__doc__
	import threading
	if float(sys.version[:3]) < 2.5:
		from asyncore import poll2 as poll
	else:
		from asyncore import poll
	try:
		poller = PdLANPoller()
		poller.Post(["my", "first", "test"])
		threadSrv = threading.Thread(target=poller.Launch)
		threadSrv.start()
		start = time()
		while 1:
			poll()
			if start < time() - 2.5:
				poller.Post(["this", "is", "just", "a", "test"])
				start = time()
			sleep(0.01)
	except KeyboardInterrupt:
		sys.exit(0)

